## pcb-rnd 3.1.4

=== tests/Makefile ===
test:
	cd RTT && $(MAKE) all && $(MAKE) test
	cd pcbflags && $(MAKE) all && $(MAKE) test
	cd strflags && $(MAKE) all && $(MAKE) test
	cd uniq_name && $(MAKE) all && $(MAKE) test
	cd propedit && $(MAKE) all && $(MAKE) test
	cd drc_pstk_hbrk && $(MAKE) all && $(MAKE) test
	cd drc_query && $(MAKE) test
	cd query && $(MAKE) test
	cd menu && $(MAKE) test
	cd cam && $(MAKE) test
	cd vendordrill && $(MAKE) test
	@echo " "
	@echo "+-------------------------------------------------+"
	@echo "+  All tests passed, pcb-rnd is safe to install.  +"
	@echo "+-------------------------------------------------+"

clean:
	cd RTT && $(MAKE) clean
	cd pcbflags && $(MAKE) clean
	cd strflags && $(MAKE) clean
	cd uniq_name && $(MAKE) clean
	cd propedit && $(MAKE) clean
	cd drc_pstk_hbrk && $(MAKE) clean
	cd drc_query && $(MAKE) clean
	cd query && $(MAKE) clean
	cd menu && $(MAKE) clean
	cd cam && $(MAKE) clean
	cd vendordrill && $(MAKE) clean

=== doc/resources/Makefile ===
ROOT=../..
RESDIR=$(DOCDIR)/resources

all:

install_all:
	$(SCCBOX) mkdir -p $(RESDIR)
	$(SCCBOX) $(HOW) -d *.png *.svg *.jpg $(RESDIR)

install:
	$(MAKE) install_all HOW="install -f -d"

linstall:
	$(MAKE) install_all HOW="install -f -l -d"

uninstall:
	$(MAKE) install_all HOW="install -u"

clean:

distclean:


include $(ROOT)/Makefile.conf

=== src_3rd/qparse/Makefile ===
#CFLAGS = -Wall -Wextra -g
CFLAGS = -g

all: example_dynamic example_static

example_dynamic: example_dynamic.o qparse.o

example_static: example_static.o qparse.o

qparse.o: qparse.c qparse.h
	$(CC) $(CFLAGS) -c qparse.c -o qparse.o

clean:
	rm qparse.o example example.o ; true

=== src_plugins/export_debug/Makefile ===
all:
	cd ../../src && $(MAKE) mod_export_debug

clean:
	rm *.o *.so 2>/dev/null ; true

=== src_plugins/export_oldconn/Makefile ===
all:
	cd ../../src && $(MAKE) mod_export_oldconn

clean:
	rm *.o *.so 2>/dev/null ; true

=== src_plugins/import_accel_net/Makefile ===
all:
	cd ../../src && $(MAKE) mod_import_accel_net

clean:
	rm *.o *.so 2>/dev/null ; true

=== src_plugins/import_net_cmd/Makefile ===
all:
	cd ../../src && $(MAKE) mod_import_net_cmd

clean:
	rm *.o *.so 2>/dev/null ; true

=== src_plugins/import_pads_net/Makefile ===
all:
	cd ../../src && $(MAKE) mod_import_pads_net

clean:
	rm *.o *.so 2>/dev/null ; true

=== src_plugins/io_hyp/Makefile ===
all:
	cd ../../src && $(MAKE) mod_io_hyp

hyp_l.o: hyp_y.h

parser.o: hyp_l.h hyp_y.h

clean:
	rm *.o *.so hyp_l.c hyp_l.h hyp_y.c hyp_y.h 2>/dev/null ; true

=== src_plugins/lib_hid_pcbui/Makefile ===
all:
	cd ../../src && $(MAKE) mod_lib_hid_pcbui

clean:
	rm *.o *.so 2>/dev/null ; true

=== src_plugins/query/Makefile ===
all:
	cd ../../src && $(MAKE) mod_query
	

clean:
	rm *.o *.so 2>/dev/null ; true

=== tests/drc_query/Makefile ===
ROOT=../..
include $(ROOT)/Makefile.conf

SRC=$(ROOT)/src
TDIR=../tests/drc_query
FLT=$(TDIR)/drc_filter.sh
GFLT=$(TDIR)/../pupfilter.sh
PCBRND=./pcb-rnd
GLOBARGS=--gui batch -c rc/library_search_paths=../tests/RTT/lib -c rc/quiet=1 -c editor/drc_inclusive_bbox=1

TESTS = \
thickness.diff overlap.diff netint.diff dwg_area.diff fullpoly.diff \
zone_clr.diff invchar.diff

test: $(TESTS)

all:

thickness.diff: thickness.out
	@diff -u thickness.ref thickness.out && rm thickness.out

thickness.out: FORCE
	@cd $(SRC) && echo "drc()" | $(PCBRND) $(GLOBARGS) $(TDIR)/thickness.lht --gui batch | $(GFLT) | $(FLT) > $(TDIR)/thickness.out

overlap.diff: overlap.out
	@diff -u overlap.ref overlap.out && rm overlap.out

overlap.out: FORCE
	@cd $(SRC) && echo "drc()" | $(PCBRND) $(GLOBARGS) $(TDIR)/overlap.lht --gui batch | $(GFLT) | $(FLT) > $(TDIR)/overlap.out

netint.diff: netint.out
	@diff -u netint.ref netint.out && rm netint.out

netint.out: FORCE
	@cd $(SRC) && echo "drc()" | $(PCBRND) $(GLOBARGS) $(TDIR)/netint.lht --gui batch | $(GFLT) | $(FLT) > $(TDIR)/netint.out

dwg_area.diff: dwg_area.out
	@diff -u dwg_area.ref dwg_area.out && rm dwg_area.out

dwg_area.out: FORCE
	@cd $(SRC) && echo "drc()" | $(PCBRND) $(GLOBARGS) $(TDIR)/dwg_area.lht --gui batch | $(GFLT) | $(FLT) > $(TDIR)/dwg_area.out

fullpoly.diff: fullpoly.out
	@diff -u fullpoly.ref fullpoly.out && rm fullpoly.out

fullpoly.out: FORCE
	@cd $(SRC) && echo "drc()" | $(PCBRND) $(GLOBARGS) $(TDIR)/fullpoly.lht --gui batch | $(GFLT) | $(FLT) > $(TDIR)/fullpoly.out

zone_clr.diff: zone_clr.out
	@diff -u zone_clr.ref zone_clr.out && rm zone_clr.out

zone_clr.out: FORCE
	@cd $(SRC) && echo "drc()" | $(PCBRND) $(GLOBARGS) $(TDIR)/zone_clr.lht --gui batch | $(GFLT) | $(FLT) > $(TDIR)/zone_clr.out

invchar.diff: invchar.out
	@diff -u invchar.ref invchar.out && rm invchar.out

invchar.out: FORCE
	@cd $(SRC) && echo "drc()" | $(PCBRND) $(GLOBARGS) $(TDIR)/invchar.lht --gui batch | $(GFLT) | $(FLT) > $(TDIR)/invchar.out

clean:
	@echo "a" > dummy.out
	rm *.out

FORCE:

=== debian/changelog ===
pcb-rnd (3.1.4-2) unstable; urgency=medium

  * remove extraneous librnd4 runtime dependencies, closes: #1068812

 -- Bdale Garbee <bdale@gag.com>  Fri, 12 Apr 2024 12:50:16 -0600

pcb-rnd (3.1.4-1) unstable; urgency=medium

  * new upstream release
  * remove gEDA package reference in dependencies
  * add Suggests for other Ringdove applications
  * update Vcs entries for new subgroup on salsa
  * patch upstream clean target, closes: #1045355

 -- Bdale Garbee <bdale@gag.com>  Wed, 13 Mar 2024 17:19:26 -0600

pcb-rnd (3.1.3-1) unstable; urgency=medium

  * new upstream version

 -- Bdale Garbee <bdale@gag.com>  Thu, 30 Nov 2023 08:39:54 -0700

pcb-rnd (3.1.2-4) unstable; urgency=medium

  * with all HID code now in the librnd package, the motif and stroke build
    deps are no longer needed here

 -- Bdale Garbee <bdale@gag.com>  Sun, 12 Nov 2023 11:05:07 -0700

pcb-rnd (3.1.2-3) unstable; urgency=medium

  * elide libepoxy-dev from build deps, only librnd needs that
  * allow either gtk 4 or lesstif to be installed HID modules

 -- Bdale Garbee <bdale@gag.com>  Thu, 09 Nov 2023 11:37:34 -0700

pcb-rnd (3.1.2-2) unstable; urgency=medium

  * switch from GTK 2 to GTK 4, closes: #967685

 -- Bdale Garbee <bdale@gag.com>  Wed, 01 Nov 2023 20:33:09 -0600

pcb-rnd (3.1.2-1) unstable; urgency=medium

  * new upstream version

 -- Bdale Garbee <bdale@gag.com>  Sun, 10 Sep 2023 18:37:41 -0600

=== debian/control ===
Source: pcb-rnd
Section: electronics
Priority: optional
Maintainer: Debian Electronics Team <pkg-electronics-devel@lists.alioth.debian.org>
Uploaders: Dima Kogan <dkogan@debian.org>, Bdale Garbee <bdale@gag.com>
Build-Depends: debhelper (>= 11), librnd4-dev, librnd4-cloud, librnd4-lib-gui, imagemagick, libgd-dev, libxml2-dev, libgenht1-dev (>= 1.1.3), libfungw-dev
Standards-Version: 4.6.0
Homepage: http://repo.hu/projects/pcb-rnd
Vcs-Git: https://salsa.debian.org/electronics-team/ringdove-eda/pcb-rnd.git
Vcs-Browser: https://salsa.debian.org/electronics-team/ringdove-eda/pcb-rnd

Package: pcb-rnd
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
	pcb-rnd-core (= ${binary:Version}),
	pcb-rnd-io-standard (= ${binary:Version}),
	pcb-rnd-io-alien (= ${binary:Version}),
	pcb-rnd-lib-gui (= ${binary:Version}),
	librnd4-hid-gtk4-gl | librnd4-hid-lesstif,
	pcb-rnd-export (= ${binary:Version}),
	pcb-rnd-export-sim (= ${binary:Version}),
	pcb-rnd-export-extra (= ${binary:Version}),
	pcb-rnd-auto (= ${binary:Version}),
	pcb-rnd-extra (= ${binary:Version}),
	pcb-rnd-cloud (= ${binary:Version}),
	pcb-rnd-doc (= ${source:Version}),
	pcb-rnd-import-net (= ${binary:Version})
Suggests: camv-rnd, route-rnd, sch-rnd
Description: Standard installation of pcb-rnd
 pcb-rnd is a highly modular PCB (Printed Circuit Board) layout tool
 with a rich set of plugins for communicating with various external
 design tools and other EDA/CAD packages.
 .
 Feature highlights:
   - subcircuits, pad stacks
   - flexible footprint model; unrestricted pad shapes
   - arbitrary copper, silk, paste and soldermask objects
   - sophisticated, flexible layer model
   - flexible/universal polygon model
   - any object, even polygons, can have a clearance within a polygon
   - advanced mil and mm grid, with support for mixed unit design
   - strong CLI support
   - static footprints and parametric (generated) footprints
   - query language for advanced search & select
   - powerful, user scriptable, modular Design Rule Checker (DRC)
   - layout optimizers such as teardrops and a trace puller
   - footprint library from local file systems, HTTP and board files
   - netlist management: imported and as-built; back annotation
 .
 File formats and compatibility:
   - text based, tree structured native file format (lihata)
   - import board:
     * Altium PcbDoc ASCII board
     * autotrax PCB board, version 4
     * autotrax PCB board, version 5
     * dsn board
     * eagle xml board version 6, 7, 8
     * eagle binary board version 3, 4, 5
     * hyperlynx board, version 2 and above
     * kicad board, version 3, 4 and 5 (s-expr)
     * lihata pcb-rnd board (any version)
     * PADS ASCII board
     * gEDA/PCB .pcb board (any version up to 2017)
   - export board:
     * anonimized board statistics in lihata
     * autotrax PCB board, version 4
     * specctra dsn board
     * hyperlynx board, version 2.0
     * kicad board, version 3 (s-expr)
     * kicad pcbnew-board, version 1 (legacy plain text format)
     * lihata pcb-rnd board (any version)
     * PADS ASCII board
     * gEDA/PCB .pcb board (various version up to 2017)
   - import footprint:
     * BXL footprints
     * eagle xml footprint lib .lbr (as board)
     * eagle xml footprint lib .lbr (as footprint)
     * eagle binary footprint lib (as board)
     * lihata pcb-rnd footprint (any version)
     * Mentor Graphics cell footprints
     * gEDA/PCB .fp footprints
     * tEDAx footprint (any version)
   - export footprint:
     * kicad module (s-expr, according to version 3)
     * kicad pcbnew-module (legacy plain text format)
     * lihata pcb-rnd footprint (any version)
     * gEDA/PCB .fp footprints
     * tEDAx footprint (any version)
   - import netlist:
     * Accel ASCII netlists + footprint info
     * calay (netlists + footprint info)
     * flat netlist from EDIF
     * freepcb netlist + footprint info
     * gEDA/gschem (netlist + footprint info, running gnetlist)
     * import ltspice .net and .asc (netlist and footprint info)
     * flat .edf (netlist+footprint, produced by Mentor Graphics Design Capture)
     * pcb-rnd action script (netlist + footprint info)
     * schematics import by running a commandline
     * netlist import by running a commandline
     * gEDA netlist (plain text, no footprint info)
     * Orcad PCB II (netlist + footprint info)
     * PADS ascii (.asc, netlists + footprint info)
     * Protel netlists 2.0 + footprint info
     * sch-rnd sheet (netlist + footprint info, running sch-rnd)
     * sch-rnd project (netlist + footprint info, running sch-rnd)
     * Ringdove project (netlist + footprint info, running sch-rnd)
     * tinycad .net (netlists + footprint info)
     * eeschema netlist and footprint info
     * tEDAx netlist (any version)
   - export netlist:
     * tEDAx netlist (any version)
   - export image:
     * render in .png
     * render in .gif
     * render in .jpeg
     * render black&white postscript (single or multiple files)
     * render black&white or color embedded postscript (single file)
     * pro (projector: 3d rendering)
     * svg (Scalable Vector Graphics)
   - import misc:
     * HPGL plot (lines, arcs, polygons)
     * MUCS unixplot .pl (lines and vias)
     * ttf font
     * specctra .dsn (route result: wires and vias)
     * specctra .ses (route result: wires and vias)
     * eagle DRU (design rules)
     * lihata pcb-rnd font (any version)
     * gEDA/PCB font
     * tEDAx drc
     * tEDAx pcb-rnd drc script
   - export misc:
     * bom (Bill of Materials, text, templated)
     * .dxf (2D drawing for mech CADs)
     * excellon drill/cnc (for PCB fabbing)
     * fidocad .fcd (partial export)
     * export gcode (for milling)
     * gerber for PCB fabbing
     * IPC-D-356 Netlist (for automated testing)
     * printer (using ps)
     * list of terminal connections (old, custom format)
     * OpenEMS (simulation, matlab files)
     * openscad script (colored 3D model)
     * stl (3d triangulated surface model)
     * amf (Additive Manufacturing File, surface model)
     * geda/PCB xy
     * gxyrs
     * Macrofab's pick&place
     * pick&place file for the TM220/TM240 device
     * KiCad .pos file
     * IPC-D-356 Netlist (from automated testing)
     * lihata pcb-rnd font (any version)
     * tEDAx etest
     * tEDAx drc
     * tEDAx pcb-rnd drc script

Package: pcb-rnd-debug
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, pcb-rnd-core (= ${binary:Version})
Description: Debug and diagnostics.
 Extra action commands to help in debugging and diagnosing problems
 and bugs.

Package: pcb-rnd-export
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, pcb-rnd-core (= ${binary:Version}), librnd4-pixmap
Description: Common export plugins.
 Export the board in vector graphics (svg, ps, eps), raster graphics
 (png, jpeg, etc.), gerber, 3d model in openscad, xy for pick and
 place, BoM, etc.

Package: pcb-rnd-doc
Architecture: all
Depends: ${misc:Depends}
Replaces: pcb-rnd (<< 2.2.0-2)
Breaks: pcb-rnd (<< 2.2.0-2)
Description: Documentation for pcb-rnd
 User manual (html) and manual pages.

Package: pcb-rnd-export-sim
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, pcb-rnd-core (= ${binary:Version})
Description: Export plugins to simulators
 Export the board in formats that can be used for simulation: openems.

Package: pcb-rnd-import-geo
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, pcb-rnd-core (= ${binary:Version})
Description: Geometry import.
 Plugins for importing pixmaps, fonts and vector graphics.

Package: pcb-rnd-import-net
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
	pcb-rnd-core (= ${binary:Version})
Replaces: pcb-rnd (<< 2.2.0-2)
Breaks: pcb-rnd (<< 2.2.0-2)
Description: Netlist/schematics import plugins.
 Import netlist and footprint information from edif, ltspice, mentor
 graphics, gschem and tinycad.

Package: pcb-rnd-auto
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
	pcb-rnd-core (= ${binary:Version}),
	pcb-rnd-lib-io (= ${binary:Version}),
	pcb-rnd-io-standard (= ${binary:Version})
Description: Autoroute and autoplace.
 Feature plugins for automated component placing and track routing.

Package: pcb-rnd-lib-io
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, pcb-rnd-core (= ${binary:Version})
Description: Support library for alien file formats.
 Provides generic, low level parsers (such as s-expression parser) for
 I/O plugins that need to deal with alien file formats.

Package: pcb-rnd-io-standard
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
	pcb-rnd-core (= ${binary:Version}),
	pcb-rnd-lib-io (= ${binary:Version})
Replaces: pcb-rnd (<< 2.2.0-2)
Breaks: pcb-rnd (<< 2.2.0-2)
Description: Commonly used non-native board and footprint file formats
 Plugins for tEDAx footprint format and the gEDA/PCB file formats
 (footprint and board).

Package: pcb-rnd-lib-gui
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, 
	pcb-rnd-core (= ${binary:Version}),
	librnd4-lib-gui
Description: Support library for building the GUI.
 Provides pcb-rnd specific dialog boxes (e.g. fontsel) and top window
 GUI elements.

Package: pcb-rnd-core
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Replaces: pcb-rnd (<< 2.2.0-2)
Breaks: pcb-rnd (<< 2.2.0-2)
Description: pcb-rnd executable with the core functionality
 Includes the data model, the most common action commands, the native
 file format.  Can be used in headless mode or batch/scripted mode for
 automated processing or with GUI (if pcb-rnd-lib-gui and librnd GUI
 HIDs are installed).

Package: pcb-rnd-io-alien
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
	pcb-rnd-core (= ${binary:Version}),
	pcb-rnd-lib-io (= ${binary:Version}),
	pcb-rnd-extra (= ${binary:Version})
Description: File format compatibility with other PCB layout designers.
 Load and/or save boards in file formats supported by other EDA tools,
 such as KiCAD, Eagle, protel/autotrax, etc.

Package: pcb-rnd-cloud
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, 
	pcb-rnd-core (= ${binary:Version}),
	librnd4-cloud,
	pcb-rnd-export (= ${binary:Version}),
Description: Networking plugins.
 'Cloud' footprint access plugin that integrates edakrill and
 gedasymbols.org.

Package: pcb-rnd-export-extra
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
	pcb-rnd-core (= ${binary:Version}),
	pcb-rnd-export (= ${binary:Version})
Description: Export formats: special/extra
 Less commonly used export formats: fidocadj, ipc-356-d, stl, old geda
 connection list format, direct printing with lpr.

Package: pcb-rnd-extra
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, pcb-rnd-core (= ${binary:Version})
Description: Extra action commands and optional functionality.
 Align objects in grid, optimize tracks, font editor, combine
 polygons, renumber subcircuits, apply vendor drill mapping.

=== debian/rules ===
#!/usr/bin/make -f

DH_VERBOSE = 1
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

%:
ifeq (mipsel,$(findstring mipsel,$(DEB_HOST_ARCH)))
	dh $@ --no-parallel
else ifeq (mips64el,$(findstring mips64el,$(DEB_HOST_ARCH)))
	dh $@ --no-parallel
else
	dh $@
endif

override_dh_auto_clean:
	# only try to run dh_auto_clean if configure has been run
	test -f Makefile.conf && dh_auto_clean || true

override_dh_auto_configure:
	./configure \
		--LDFLAGS='$(LDFLAGS)' \
		--CFLAGS='$(CFLAGS) $(CPPFLAGS)' \
		\
		--symbols \
		--prefix=/usr \
		--confdir=/etc/pcb-rnd \
		--prefix/libs/script/fungw=/dev/null \
		\
		--all=disable \
		--buildin-fp_fs \
		--buildin-draw_fab \
		--buildin-act_read \
		--buildin-drc_query \
		--buildin-mincut \
		--buildin-ch_onpoint \
		--buildin-report \
		--buildin-rubberband_orig \
		--buildin-exto_std \
		--buildin-fp_board \
		--buildin-propedit \
		--buildin-io_lihata \
		--buildin-autocrop \
		--buildin-lib_polyhelp \
		--buildin-draw_csect \
		--buildin-ddraft \
		--buildin-ch_editpoint \
		--buildin-act_draw \
		--buildin-tool_std \
		--buildin-show_netnames \
		--buildin-query \
		--buildin-lib_compat_help \
		--buildin-shape \
		--buildin-lib_formula \
		--buildin-extedit \
		--plugin-export_excellon \
		--plugin-export_fidocadj \
		--plugin-export_lpr \
		--plugin-export_oldconn \
		--plugin-export_stat \
		--plugin-io_kicad_legacy \
		--plugin-io_eagle \
		--plugin-io_tedax \
		--plugin-import_gnetlist \
		--plugin-io_kicad \
		--plugin-import_mucs \
		--plugin-renumber \
		--plugin-import_calay \
		--plugin-smartdisperse \
		--plugin-draw_fontsel \
		--plugin-polycombine \
		--plugin-export_gcode \
		--plugin-export_bom \
		--plugin-ar_cpcb \
		--plugin-lib_hid_pcbui \
		--plugin-teardrops \
		--plugin-shand_cmd \
		--plugin-io_pads \
		--plugin-import_tinycad \
		--plugin-export_openems \
		--plugin-import_orcad_net \
		--plugin-order_pcbway \
		--plugin-import_ltspice \
		--plugin-export_dxf \
		--plugin-export_ipcd356 \
		--plugin-import_ttf \
		--plugin-import_mentor_sch \
		--plugin-export_ps \
		--plugin-import_accel_net \
		--plugin-millpath \
		--plugin-djopt \
		--plugin-import_edif \
		--plugin-import_protel_net \
		--plugin-import_sch2 \
		--plugin-diag \
		--plugin-export_stl \
		--plugin-autoplace \
		--plugin-export_svg \
		--plugin-import_net_cmd \
		--plugin-fp_wget \
		--plugin-fontmode \
		--plugin-import_netlist \
		--plugin-polystitch \
		--plugin-order \
		--plugin-import_pads_net \
		--plugin-dialogs \
		--plugin-import_sch_rnd \
		--plugin-io_dsn \
		--plugin-export_xy \
		--plugin-export_png \
		--plugin-import_hpgl \
		--plugin-import_ipcd356 \
		--plugin-lib_netmap \
		--plugin-io_hyp \
		--plugin-cam \
		--plugin-puller \
		--plugin-import_fpcb_nl \
		--plugin-io_pcb \
		--plugin-distalign \
		--plugin-asm \
		--plugin-export_openscad \
		--plugin-jostle \
		--plugin-autoroute \
		--plugin-io_autotrax \
		--plugin-vendordrill \
		--plugin-export_gerber \
		--plugin-io_bxl \
		--plugin-ar_extern \
		--plugin-import_net_action \

## pcb-rnd 3.1.5

=== debian/changelog ===
pcb-rnd (3.1.5-2) unstable; urgency=medium

  * eliminate versioned librnd4 run-time dependencies, since in the post-t64
    transition world, the only librnd4t64 in the archive is new enough,
    closes: #1076279
  * replace libraqm-dev build dep with versioned libgd-dev build dep now that
    bug 1076152 is closed.

 -- Bdale Garbee <bdale@gag.com>  Sat, 13 Jul 2024 17:02:13 -0600

pcb-rnd (3.1.5-1) unstable; urgency=medium

  * new upstream release
  * add libraqm-dev build-dep to work around broken libgd-dev

 -- Bdale Garbee <bdale@gag.com>  Thu, 11 Jul 2024 11:45:49 -0400

pcb-rnd (3.1.4-3) unstable; urgency=medium

  * use the same CFLAGS as librnd for compatibility

 -- Bdale Garbee <bdale@gag.com>  Wed, 12 Jun 2024 11:49:43 -0600

## pcb-rnd 3.1.6

=== doc/tutorials/Makefile ===
all:
	$(MAKE) all_ CMD=all

all_:
	cd 15_no_sch && $(MAKE) -f Makefile.inst $(CMD)
	cd 16_tdx_netlist && $(MAKE) -f Makefile.inst $(CMD)
	cd 17_sch && $(MAKE) -f Makefile.inst $(CMD)

install:
	$(MAKE) all_ CMD=install

linstall:
	$(MAKE) all_ CMD=linstall

uninstall:
	$(MAKE) all_ CMD=uninstall

clean:

distclean:

=== src_3rd/libnanojson/Makefile ===
CFLAGS = -Wall -std=c89 -ansi -pedantic -g -I..

all: njson_dump njson_sem_dump

njson_dump: njson_dump.o nanojson.o

njson_sem_dump: njson_sem_dump.o nanojson.o semantic.o

njson_sem_dump.o: njson_sem_dump.c nanojson.h semantic.h

nanojson.o: nanojson.c nanojson.h

semantic.o: semantic.c semantic.h

=== src_3rd/libucdf/Makefile ===
CFLAGS = -Wall -g

tester: tester.o ucdf.o

tester.o: tester.c ucdf.h

ucdf.o: ucdf.c ucdf.h

clean:
	-rm ucdf.o tester.o tester

=== src_3rd/libuhpgl/Makefile ===
CFLAGS = -Wall -g -ansi -pedantic

parse.o: parse.c uhpgl_math.h libuhpgl.h arc_iterate.h

=== src_plugins/autoplace/Makefile ===
all:
	cd ../../src && $(MAKE) mod_autoplace

clean:
	rm *.o *.so 2>/dev/null ; true

=== src_plugins/draw_pnp/Makefile ===
all:
	cd ../../src && $(MAKE) mod_draw_pnp

clean:
	rm *.o *.so 2>/dev/null ; true

=== src_plugins/drc_query/Makefile ===
all:
	cd ../../src && $(MAKE) mod_drc_query

clean:
	rm *.o *.so 2>/dev/null ; true

=== src_plugins/export_c_draw/Makefile ===
all:
	cd ../../src && $(MAKE) mod_export_c_draw

clean:
	rm *.o *.so 2>/dev/null ; true

=== src_plugins/export_fidocadj/Makefile ===
all:
	cd ../../src && $(MAKE) mod_export_fidocadj

clean:
	rm *.o *.so 2>/dev/null ; true

=== src_plugins/export_ps/Makefile ===
all:
	cd ../../src && $(MAKE) mod_export_ps

clean:
	rm *.o *.so 2>/dev/null ; true

=== src_plugins/fp_board/Makefile ===
all:
	cd ../../src && $(MAKE) mod_fp_board

clean:
	rm *.o *.so 2>/dev/null ; true

=== src_plugins/import_gnetlist/Makefile ===
all:
	cd ../../src && $(MAKE) mod_import_gnetlist

clean:
	rm *.o *.so 2>/dev/null ; true

=== debian/changelog ===
pcb-rnd (3.1.6-1) unstable; urgency=medium

  * new upstream release
  * actually install the desktop file so pcb-rnd shows up in menus

 -- Bdale Garbee <bdale@gag.com>  Thu, 12 Dec 2024 01:45:52 -0700

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Debian Electronics Team <pkg-electronics-devel@lists.alioth.debian.org>
 Uploaders: Dima Kogan <dkogan@debian.org>, Bdale Garbee <bdale@gag.com>
-Build-Depends: debhelper (>= 11), librnd4-dev, librnd4-cloud, librnd4-lib-gui, imagemagick, libgd-dev, libxml2-dev, libgenht1-dev (>= 1.1.3), libfungw-dev
+Build-Depends: debhelper (>= 11), librnd4-dev, librnd4-cloud, librnd4-lib-gui, imagemagick, libgd-dev (>= 2.3.3-12), libxml2-dev, libgenht1-dev (>= 1.1.3), libfungw-dev, pkgconf
 Standards-Version: 4.6.0
 Homepage: http://repo.hu/projects/pcb-rnd
 Vcs-Git: https://salsa.debian.org/electronics-team/ringdove-eda/pcb-rnd.git
@@ -135,6 +135,7 @@
      * fidocad .fcd (partial export)
      * export gcode (for milling)
      * gerber for PCB fabbing
+     * hpgl
      * IPC-D-356 Netlist (for automated testing)
      * printer (using ps)
      * list of terminal connections (old, custom format)
@@ -162,7 +163,7 @@
 
 Package: pcb-rnd-export
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}, pcb-rnd-core (= ${binary:Version}), librnd4-pixmap
+Depends: ${misc:Depends}, ${shlibs:Depends}, pcb-rnd-core (= ${binary:Version}), librnd4-pixmap (>= 4.2.0)
 Description: Common export plugins.
  Export the board in vector graphics (svg, ps, eps), raster graphics
  (png, jpeg, etc.), gerber, 3d model in openscad, xy for pick and
@@ -190,8 +191,7 @@
 
 Package: pcb-rnd-import-net
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends},
-	pcb-rnd-core (= ${binary:Version})
+Depends: ${misc:Depends}, ${shlibs:Depends}, pcb-rnd-core (= ${binary:Version})
 Replaces: pcb-rnd (<< 2.2.0-2)
 Breaks: pcb-rnd (<< 2.2.0-2)
 Description: Netlist/schematics import plugins.
@@ -229,7 +229,7 @@
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}, 
 	pcb-rnd-core (= ${binary:Version}),
-	librnd4-lib-gui
+	librnd4-lib-gui (>= 4.2.0)
 Description: Support library for building the GUI.
  Provides pcb-rnd specific dialog boxes (e.g. fontsel) and top window
  GUI elements.
@@ -258,8 +258,8 @@
 Package: pcb-rnd-cloud
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}, 
-	pcb-rnd-core (= ${binary:Version}),
-	librnd4-cloud,
+	librnd4-cloud (>= 4.2.0),
+	pcb-rnd-core (= ${binary:Version}),
 	pcb-rnd-export (= ${binary:Version}),
 Description: Networking plugins.
  'Cloud' footprint access plugin that integrates edakrill and

=== debian/rules ===
--- 
+++ 
@@ -4,6 +4,10 @@
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
 DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
+
+# Workaround on exotic archs, probably any 32 bit arch with 64 bit kernel
+# see bug #1019729
+CFLAGS += -D_LARGE_FILE_SOURCE=1 -D_FILE_OFFSET_BITS=64
 
 %:
 ifeq (mipsel,$(findstring mipsel,$(DEB_HOST_ARCH)))
@@ -54,6 +58,7 @@
 		--buildin-shape \
 		--buildin-lib_formula \
 		--buildin-extedit \
+		--buildin-draw_pnp \
 		--plugin-export_excellon \
 		--plugin-export_fidocadj \
 		--plugin-export_lpr \
@@ -99,6 +104,7 @@
 		--plugin-export_svg \
 		--plugin-import_net_cmd \
 		--plugin-fp_wget \
+		--plugin-export_hpgl \
 		--plugin-fontmode \
 		--plugin-import_netlist \
 		--plugin-polystitch \

## pcb-rnd 3.1.7b

=== Makefile ===
all: FORCE
	cd src && $(MAKE)
	cd util && $(MAKE)
	cd footprint && $(MAKE)
#	cd doc && $(MAKE)

test: FORCE
	cd tests && $(MAKE) test

clean: FORCE
	cd src && $(MAKE) clean
	cd util && $(MAKE) clean
	cd footprint && $(MAKE) clean
#	cd doc && $(MAKE) clean
	cd tests && $(MAKE) clean
	cd src_3rd/libminuid && $(MAKE) clean ; true
	cd src_3rd/libuundo && $(MAKE) clean ; true

# Note: have to distclean utils (and tests) before src because of hidlib deps
distclean: FORCE
	$(MAKE) clean ; true
#	cd doc && $(MAKE) distclean
	cd util && $(MAKE) distclean
	cd src && $(MAKE) distclean
	cd src_3rd/genregex && $(MAKE) clean ; true
	cd src_3rd/qparse && $(MAKE) clean ; true
	cd scconfig && $(MAKE) distclean ; true


install: FORCE
	cd src && $(MAKE) install
	cd util && $(MAKE) install
	cd footprint && $(MAKE) install
	cd doc && $(MAKE) install

linstall: FORCE
	cd src && $(MAKE) linstall
	cd util && $(MAKE) linstall
	cd footprint && $(MAKE) linstall
	cd doc && $(MAKE) linstall

uninstall: FORCE
	cd src && $(MAKE) uninstall
	cd util && $(MAKE) uninstall
	cd footprint && $(MAKE) uninstall
	cd doc && $(MAKE) uninstall

include Makefile.conf

FORCE:

=== doc/Makefile ===
MENU_RES=../src/menu-default.lht ../src_plugins/*/*-menu.lht
ROOT=..

all: keys.html user/05_ui/04_common/keytree.svg user/05_ui/04_common/keytree.txt
	ROOT="" ./Autostyle.sh *.html
	LIBRND_LIBDIR="$(LIBRND_LIBDIR)" ./datasheet.sh

include ../Makefile.conf
include $(LIBRND_MAK)

user/05_ui/04_common/keytree.svg: $(MENU_RES) $(KEYLIST)
	$(KEYLIST) --dot user/05_ui/04_common/src/node_names.txt $(MENU_RES) > user/05_ui/04_common/keytree.dot
	dot -Tsvg < user/05_ui/04_common/keytree.dot >user/05_ui/04_common/keytree.svg

user/05_ui/04_common/keytree.txt: $(MENU_RES) $(KEYLIST)
	$(KEYLIST) --lst $(MENU_RES) > user/05_ui/04_common/keytree.txt


keys.html: $(MENU_RES) $(KEYLIST)
	$(KEYLIST) $(MENU_RES) > keys.html

install_main:
	$(SCCBOX) $(HOW) *.html *.txt TODO $(DOCDIR)/

install:
	$(SCCBOX) mkdir -p "$(DOCDIR)"
	cd man && $(MAKE) install
	cd user && $(MAKE) install
	cd resources && $(MAKE) install
	cd tutorials && $(MAKE) install
	cd security && $(MAKE) install
	cd conf && $(MAKE) install
	cd developer && $(MAKE) install
	$(MAKE) install_main HOW="install -f -d"

linstall:
	cd man && $(MAKE) linstall
	cd user && $(MAKE) linstall
	cd resources && $(MAKE) linstall
	cd tutorials && $(MAKE) linstall
	cd security && $(MAKE) linstall
	cd conf && $(MAKE) linstall
	cd developer && $(MAKE) linstall
	$(MAKE) install_main HOW="install -f -l -d"

uninstall:
	cd man && $(MAKE) uninstall
	cd user && $(MAKE) uninstall
	cd resources && $(MAKE) uninstall
	cd tutorials && $(MAKE) uninstall
	cd security && $(MAKE) uninstall
	cd conf && $(MAKE) uninstall
	cd developer && $(MAKE) uninstall
	$(MAKE) install_main HOW="install -f -u -d"

clean:
	cd man && $(MAKE) clean
	cd user && $(MAKE) clean
	cd tutorials && $(MAKE) clean
	cd security && $(MAKE) clean
	cd conf && $(MAKE) clean
	cd developer && $(MAKE) clean

distclean:
	cd man && $(MAKE) distclean
	cd user && $(MAKE) distclean
	cd tutorials && $(MAKE) distclean
	cd security && $(MAKE) distclean
	cd conf && $(MAKE) distclean
	cd developer && $(MAKE) distclean

=== scconfig/Makefile ===
# --- configuration part --

# - generic configuration -
LIBRND_PREFIX=/usr
SRC=src
BIN=$(SRC)

#  what cflags to use to compile scconfig
USER_CFLAGS = -g -DGENCALL -I$(SRC) -I../src_3rd $(LIBRND_EXTRA_INCLUDE)
#USER_CFLAGS = -Wall -Wextra -g -DGENCALL -Isrc

#  what ldflags to use to link scconfig
USER_LDFLAGS =

#  in case hooks.c needs to link to something local
USER_OBJS = $(BIN)/util/arg_auto_set.o

#  what to build - a ./configure
all: configure cquote

# This line imports scconfig core and default tests
include $(SRC)/default/Makefile.plugin

#
# - PLUGINS -
#
#  Comment this line if you are not interested in c99 features
include $(SRC)/c99/Makefile.plugin

#  Comment this line if you do not need script libs to be detected
include $(SRC)/scripts/Makefile.plugin

#  Comment this line if you do not need parser libs to be detected
# include $(SRC)/parser/Makefile.plugin

#  Comment this line if you do not need to detect parser generators
include $(SRC)/parsgen/Makefile.plugin

#  Comment this line if you do not need math related libs
include $(SRC)/math/Makefile.plugin

#  Comment this line if you do not need socket/networking
include $(SRC)/socket/Makefile.plugin

#  Comment this line if you do not need user/password API detection
include $(SRC)/userpass/Makefile.plugin

#  Comment this line if you do not need gui (X11, toolkits)
include $(SRC)/gui/Makefile.plugin

#  Comment this line if you do not need software utility libs (glib)
include $(SRC)/sul/Makefile.plugin

#  Uncomment this line if you need menus
include $(SRC)/menulib/Makefile.plugin

#  Comment this line if you do not need generator (templating)
include $(SRC)/generator/Makefile.plugin.legacy

#  Comment this line if you do not need tmpasm (templating)
include $(SRC)/tmpasm/Makefile.plugin

# --- you shouldn't edit the lines below ---
OBJS = $(USER_OBJS) hooks.o librnd_ver.o $(DEFAULT_NOMAIN_OBJS) $(SCRIPT_OBJS) $(PARSER_OBJS) $(GENERATOR_OBJS) $(TMPASM_OBJS) $(C99_OBJS) $(PARSGEN_OBJS) $(MATH_OBJS) $(SOCKET_OBJS) $(USERPASS_OBJS) $(GUI_OBJS) $(SUL_OBJS)
CFLAGS = $(USER_CFLAGS) $(DEFAULT_CFLAGS) $(SCRIPT_CFLAGS) $(PARSER_CFLAGS) $(GENERATOR_CFLAGS) $(TMPASM_CFLAGS) $(C99_CFLAGS) $(PARSGEN_CFLAGS) $(MATH_CFLAGS) $(SOCKET_CFLAGS) $(USERPASS_CFLAGS) $(GUI_CFLAGS)  $(SUL_CFLAGS) $(MENULIB_CFLAGS) -I$(SRC)/default -I. -DLIBRND_PREFIX="$(LIBRND_PREFIX)"
LDFLAGS = $(USER_LDFLAGS) $(DEFAULT_LDFLAGS) $(SCRIPT_LDFLAGS) $(PARSER_LDFLAGS) $(GENERATOR_LDFLAGS) $(TMPASM_LDFLAGS) $(C99_LDFLAGS) $(PARSGEN_LDFLAGS) $(MATH_LDFLAGS) $(SOCKET_LDFLAGS) $(USERPASS_LDFLAGS) $(GUI_LDFLAGS) $(SUL_LDFLAGS) $(MENULIB_LDFLAGS)

all: configure revtest sccbox

revtest: revtest.o
	$(CC) -o revtest revtest.o

revtest.o: revtest.c  Rev.h
	$(CC) -c $(CFLAGS) -o revtest.o revtest.c

configure: $(OBJS)  $(DEFAULT_MAIN_OBJS)
	$(CC) -o configure $(OBJS)  $(DEFAULT_MAIN_OBJS)

menuconfig: menucfg
	./menucfg

menucfg: $(OBJS) $(MENULIB_OBJS) $(BIN)/default/main_lib.o $(BIN)/default/main_custom_args.o menucfg.o $(BIN)/util/arg_auto_menu.o $(BIN)/util/arg_auto_set.o
	$(CC) -o menucfg $(OBJS) $(MENULIB_OBJS) menucfg.o $(BIN)/default/main_lib.o $(BIN)/default/main_custom_args.o $(BIN)/util/arg_auto_menu.o

menucfg.o: menucfg.c
	$(CC) -c $(CFLAGS) -o menucfg.o menucfg.c

LIBRNDSCC=$(LIBRND_PREFIX)/include/librnd4/librnd/scconfig
RNDHOOKS=$(LIBRNDSCC)/plugin_3state.h $(LIBRNDSCC)/hooks_common.h

hooks.o: hooks.c $(RNDHOOKS) plugins.h Rev.h $(LIBRND_PREFIX)/include/librnd4/librnd/scconfig

librnd_ver.o: librnd_ver.c $(LIBRND_PREFIX)/include/librnd4/librnd/config.h
	$(CC) -c $(CFLAGS) -o librnd_ver.o librnd_ver.c

$(BIN)/util/arg_auto_set.o: $(SRC)/util/arg_auto_set.c $(SRC)/util/arg_auto_set.h
	$(CC) -c $(CFLAGS) -o $(BIN)/util/arg_auto_set.o $(SRC)/util/arg_auto_set.c

$(BIN)/util/sccbox.o: $(SRC)/util/sccbox.c
	$(CC) -c $(CFLAGS) -o $(BIN)/util/sccbox.o $(SRC)/util/sccbox.c

sccbox: $(BIN)/util/sccbox.o
	$(CC) $(LDFLAGS) -o sccbox $(BIN)/util/sccbox.o

cquote: $(SRC)/util/cquote.c
	$(CC) $(CFLAGS) $(LDFLAGS) -o cquote $(SRC)/util/cquote.c

clean:
	-rm $(OBJS) $(DEFAULT_MAIN_OBJS) configure revtest revtest.o cquote core $(BIN)/util/sccbox.o

distclean:
	-rm ../config.h ../Makefile.conf ../src/Makefile ../util/gsch2pcb-rnd/Makefile config.cache config.log Rev.stamp sccbox gmon.out ../src_3rd/puplug/Makefile ../src_3rd/puplug/config.h ../src_plugins/lib_hid_gl/opengl.h
	-$(MAKE) clean

=== tests/Makefile ===
--- 
+++ 
@@ -9,7 +9,9 @@
 	cd query && $(MAKE) test
 	cd menu && $(MAKE) test
 	cd cam && $(MAKE) test
+	cd cam_partial && $(MAKE) test
 	cd vendordrill && $(MAKE) test
+	cd pstk_crescent && $(MAKE) test
 	@echo " "
 	@echo "+-------------------------------------------------+"
 	@echo "+  All tests passed, pcb-rnd is safe to install.  +"
@@ -26,5 +28,7 @@
 	cd query && $(MAKE) clean
 	cd menu && $(MAKE) clean
 	cd cam && $(MAKE) clean
+	cd cam_partial && $(MAKE) clean
 	cd vendordrill && $(MAKE) clean
+	cd pstk_crescent && $(MAKE) clean

=== util/Makefile ===
# plain old hand crafted Makefile
ROOT=..

all:
	cd gsch2pcb-rnd && $(MAKE) all
	cd bxl2txt && $(MAKE) all
	cd rect-union-rnd && $(MAKE) all

include $(ROOT)/Makefile.conf

clean:
	cd gsch2pcb-rnd && $(MAKE) clean
	cd bxl2txt && $(MAKE) clean
	cd rect-union-rnd && $(MAKE) clean

distclean:
	cd gsch2pcb-rnd && $(MAKE) distclean
	cd bxl2txt && $(MAKE) distclean
	cd rect-union-rnd && $(MAKE) distclean


install_all:
	$(SCCBOX) mkdir -p  "$(BINDIR)" "$(LIBDIR)"
	$(SCCBOX) $(HOW) "fp2preview" "$(BINDIR)/fp2preview"
	$(SCCBOX) $(HOW) "fp2subc" "$(BINDIR)/fp2subc"
	$(SCCBOX) $(HOW) "pcb-prj2lht" "$(BINDIR)/pcb-prj2lht"
	$(SCCBOX) $(HOW) "pcb-rnd-svg" "$(BINDIR)/pcb-rnd-svg"
	$(SCCBOX) $(HOW) "gnet-pcbrndfwd.scm" "$(LIBDIR)/gnet-pcbrndfwd.scm"
	$(SCCBOX) $(HOW) "gnet-pcbrndfwd_elem.scm" "$(LIBDIR)/gnet-pcbrndfwd_elem.scm"

install:
	$(MAKE) install_all HOW="install -f"
	cd gsch2pcb-rnd && $(MAKE) install
	cd bxl2txt && $(MAKE) install
	cd rect-union-rnd && $(MAKE) install

linstall:
	$(MAKE) install_all HOW="linstall -f"
	cd gsch2pcb-rnd && $(MAKE) linstall
	cd bxl2txt && $(MAKE) linstall
	cd rect-union-rnd && $(MAKE) linstall

uninstall:
	$(MAKE) install_all HOW="uninstall"
	cd gsch2pcb-rnd && $(MAKE) uninstall
	cd bxl2txt && $(MAKE) uninstall
	cd rect-union-rnd && $(MAKE) uninstall

=== doc/man/Makefile ===
# This Makefile is a plain old hand written one; all configuration settings
# are included from $(ROOT)/Makefile.conf which is scconfig generated
ROOT=../..

IN=pcb-rnd.1.mml pcb-prj2lht.1.mml fp2preview.1.mml fp2subc.1.mml bxl2txt.1.mml txt2bxl.1.mml pcb-rnd-svg.1.mml
OUT_HTML = pcb-rnd.1.html pcb-prj2lht.1.html fp2preview.1.html fp2subc.1.html bxl2txt.1.html txt2bxl.1.html pcb-rnd-svg.1.html
OUT_MAN1 = pcb-rnd.1 pcb-prj2lht.1 fp2preview.1 fp2subc.1 bxl2txt.1 txt2bxl.1 pcb-rnd-svg.1
OUT_LINT = pcb-rnd.1.lint pcb-prj2lht.1.lint fp2preview.1.lint fp2subc.1.lint bxl2txt.1.lint txt2bxl.1.lint pcb-rnd-svg.1.lint

OUTPUT = $(OUT_HTML) $(OUT_MAN1) index.html
MML = /usr/bin/mml

all: $(OUTPUT)

lint: $(OUT_LINT)

.SUFFIXES: .html .mml .lint

.mml.html: .mml_linkmap
	$(MML) -i copyright.mml -f html $<  > $@

.mml:
	$(MML) -i copyright.mml -f man $<  > $@

.mml_linkmap:
	$(MML) -i copyright.mml -f linkmap $(IN) > $@

index.html: $(IN)
	@echo '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">' > $@
	@echo '<HTML><HEAD><meta http-equiv="Content-Type" content="text/html;charset=us-ascii"><TITLE>man page index - pcb-rnd</TITLE></HEAD><BODY><UL>' >> $@
	$(MML) -i copyright.mml -f indexhtml $(IN) >> $@
	@echo "</UL></BODY></HTML>" >> $@

clean:

distclean:

genclean:
	rm $(OUTPUT) 2>/dev/null ; true

.mml.lint:
	$(MML) -i copyright.mml -f lint $<

install_all:
	$(SCCBOX) mkdir -p "$(MAN1DIR)"
	$(SCCBOX) $(HOW) "pcb-rnd.1" "$(MAN1DIR)/pcb-rnd.1"
	$(SCCBOX) $(HOW) "pcb-prj2lht.1" "$(MAN1DIR)/pcb-prj2lht.1"
	$(SCCBOX) $(HOW) "gsch2pcb-rnd.1" "$(MAN1DIR)/gsch2pcb-rnd.1"
	$(SCCBOX) $(HOW) "fp2preview.1" "$(MAN1DIR)/fp2preview.1"
	$(SCCBOX) $(HOW) "fp2subc.1" "$(MAN1DIR)/fp2subc.1"
	$(SCCBOX) $(HOW) "pcb-rnd-svg.1" "$(MAN1DIR)/pcb-rnd-svg.1"
	$(SCCBOX) $(HOW) "bxl2txt.1" "$(MAN1DIR)/bxl2txt.1"
	$(SCCBOX) $(HOW) "txt2bxl.1" "$(MAN1DIR)/txt2bxl.1"

install:
	$(MAKE) install_all HOW="install -f"

linstall:
	$(MAKE) install_all HOW="linstall -f"

uninstall:
	$(MAKE) install_all HOW="uninstall"

include $(ROOT)/Makefile.conf

=== doc/user/Makefile ===
ROOT=../..
USERDIR=$(DOCDIR)/user

INSTD = 02_model 03_data 04_invoc 05_ui 06_feature 07_io \
        08_util 09_appendix

all: pdf

include $(ROOT)/Makefile.conf
include $(LIBRND_MAK)

pdf: user1.pdf user2.pdf user3.pdf

ps_logo.png: ../resources/logo32.png
	cp ../resources/logo32.png ps_logo.png

ps_header.png: ../resources/header_600.png
	cp ../resources/header_600.png ps_header.png

user1.ps: ps1.lst $(BUILD_PS) default.css Makefile ps_logo.png ps_header.png
	HTML2PS_OPTS="-f default.css --toc h" HTML2PS_SED="s^%%%volume%%%^Volume 1: Core functionality^;s^%%%ver%%%^Version $(PCB_RND_VER)^g" $(BUILD_PS) `cat ps1.lst` > user1.ps

user2.ps: ps2.lst $(BUILD_PS) default.css Makefile ps_logo.png ps_header.png
	HTML2PS_OPTS="-f default.css --toc h" HTML2PS_SED="s^%%%volume%%%^Volume 2: Plugins and utilities^;s^%%%ver%%%^Version $(PCB_RND_VER)^g" $(BUILD_PS) `cat ps2.lst` > user2.ps

user3.ps: ps3.lst $(BUILD_PS) default.css Makefile ps_logo.png ps_header.png
	HTML2PS_OPTS="-f default.css --toc h" HTML2PS_SED="s^%%%volume%%%^Volume 3: Appendix and misc^;s^%%%ver%%%^Version $(PCB_RND_VER)^g" $(BUILD_PS) `cat ps3.lst` > user3.ps

user1.pdf: user1.ps
	ps2pdf user1.ps

user2.pdf: user2.ps
	ps2pdf user2.ps

user3.pdf: user3.ps
	ps2pdf user3.ps

ps.lst.vols: */*.html */*.png ./listlnk Makefile
	./listlnk list -v | grep -v "^index.html	\|[.]png	\|[.]svg	\|[.]pcb\|	[.]lht\|keytree.txt" > ps.lst.vols

ps1.lst: */*.html */*.png ps.lst.vols
	echo "ps_title.html" > ps1.lst
	awk -F "	" '($$2 == 1) {print $$1}' < ps.lst.vols >> ps1.lst

ps2.lst: */*.html */*.png ps.lst.vols
	echo "ps_title.html" > ps2.lst
	awk -F "	" '($$2 == 2) {print $$1}' < ps.lst.vols >> ps2.lst

ps3.lst: */*.html */*.png ps.lst.vols
	echo "ps_title.html" > ps3.lst
	awk -F "	" '($$2 == 3) {print $$1}' < ps.lst.vols >> ps3.lst

include Makefile.inst

regen: instgen
	./instgen

install:
	$(MAKE) install_all HOW="install -f"

linstall:
	$(MAKE) install_all HOW="install -f -l --absolute "

uninstall:
	$(MAKE) install_all HOW="install -u"

include $(ROOT)/Makefile.conf

=== src_3rd/genprique/Makefile ===
# where to install:
PREFIX=/usr/local
INCDIR=$(DESTDIR)$(inst_root)$(PREFIX)/include/genprique
LIBDIR=$(DESTDIR)$(inst_root)$(PREFIX)/lib

CFLAGS_CFG=-O3
#CFLAGS_CFG=-Wall -g
CFLAGS = $(CFLAGS_CFG) -I.. $(CFLAGS_genprique)

OBJSA=fibheap.o
LIBA=genprique.a
PWD=`pwd`

all: $(LIBA) main

fibheap.o: fibheap.c fibheap.h
	$(CC) $(CFLAGS) -c fibheap.c -o fibheap.o

$(LIBA): $(OBJSA)
	touch $(LIBA)
	rm $(LIBA)
	ar ru $(LIBA) $(OBJSA)

main: main.o fibheap.o
	$(CC) $(LDFLAGS) -o main main.o fibheap.o

main.o: main.c fibheap.h
	$(CC) $(CFLAGS) -c main.c -o main.o

test: main
	./main > main.out
	diff main.ref main.out

install_: $(LIBA)
	mkdir -p $(LIBDIR) $(INCDIR)
	$(CP) $(PWD)/genprique.h          $(INCDIR)/genprique.h
	$(CP) $(PWD)/$(LIBA)              $(LIBDIR)/$(LIBA)

uninstall:
	-rm $(INCDIR)/fibheap.h $(LIBDIR)/$(LIBA)
	-rmdir $(INCDIR)

install:
	make install_ CP="cp"

linstall:
	make install_ CP="ln -s"

clean:
	-rm $(LIBA) $(OBJSA)

=== src_3rd/libcdtr/Makefile ===
#CFLAGS_DBG=-Wall -O0 -g3 
#CFLAGS_COORDT=-DCDT_COORD_T=double -Dcdt_precision=1000000.0

LIBRND_PREFIX=/usr/local

CFLAGS=$(CFLAGS_DBG) $(CFLAGS_COORDT) $(CFLAGS_LIBCDTR) -I. -I.. -I../.. -I$(LIBRND_PREFIX)/include/librnd4/librnd/src_3rd
LDFLAGS=-lm $(LDFLAGS_LIBCDTR)

OBJS= cdt.o point.o edge.o triangle.o debug.o
LIBA=libcdtr.a

DEP_OBJS=$(OBJS)

cdt_test: cdt_test.o $(OBJS)

include Makefile.dep
include Makefile.comp

$(LIBA): $(OBJS)
	@touch $(LIBA)
	@rm $(LIBA)
	@ar ru $(LIBA) $(OBJS)
	-ar s $(LIBA)
	-ranlib $(LIBA)

cdt_test.o: cdt_test.c
	$(CC) $(CFLAGS) -c cdt_test.c -o $@

test:
	cd regression && ./Test.sh

# not portable; run this only if you have gcc installed
dep:
	for o in $(DEP_OBJS); do gcc -MT $$o -MM $${o%%.o}.c  $(CFLAGS); done > Makefile.dep
	for o in $(DEP_OBJS); do echo "$$o: $${o%%.o}.c"; echo '	$$(CC) $$(CFLAGS) -c -o ' "$$o $${o%%.o}.c"; echo ""; done > Makefile.comp

clean:
	-touch $(LIBA) $(OBJS) cdt_test.o cdt_test
	-rm $(LIBA) $(OBJS) cdt_test.o cdt_test

=== src_3rd/libgrbs/Makefile ===
ROOT=../..
SRC_3RD=$(ROOT)/src_3rd
CFLAGS = -Wall -g -I$(SRC_3RD) -I..
LIBS = $(SRC_3RD)/libualloc/libualloc.a $(SRC_3RD)/genht/libgenht.a $(SRC_3RD)/genvector/vtp0.o
LDFLAGS = -lm
OBJS=tester.o grbs.o debug.o addr_hash.o rtree.o snapshot.o

# These are #included in grbs.o for best link time optimization
GRBS_C=\
  route_common.c route_next.c route_realize.c route_remove.c route_modify.c \
  route_detach.c route_sanity.c obj_line.c obj_arc.c obj_point.c collision.c \
  addr.c geo.c force_attach.c force_attach.h

tester: $(OBJS)
	$(CC) -o tester $(OBJS) $(LIBS) $(LDFLAGS)

tester.o: tester.c grbs.h debug.h route.h

grbs.o: grbs.c $(GRBS_C)  grbs.h route.h debug.h addr_hash.h

debug.o: debug.c debug.h grbs.h

addr_hash.o: addr_hash.c addr_hash.h grbs.h

clean:
	-rm $(OBJS) tester

test:
	cd regression && ./Test.sh
	@echo "*** QC pass ***"

=== src_3rd/libusearch/Makefile ===
# where to install:
PREFIX=/usr/local
INCDIR=$(DESTDIR)$(inst_root)$(PREFIX)/include/libusearch
LIBDIR=$(DESTDIR)$(inst_root)$(PREFIX)/lib

#CFLAGS_CFG = -O3
CFLAGS_CFG= -Wall -g
CFLAGS = $(CFLAGS_CFG) -I.. -I../src_3rd $(CFLAGS_LIBUSEARCH)

LIBA = libusearch.a
OBJS = a_star_impl.o

all: tester libusearch.a

$(LIBA): $(OBJS)
	-rm $(LIBA)
	ar ru $(LIBA) $(OBJS)

a_star_impl.o: a_star_api.h a_star_impl.h common.h

tester: tester.o ../src_3rd/genprique/fibheap.o

tester.o: tester.c a_star_api.h a_star_impl.h common.h

install_: $(LIBA)
	mkdir -p $(LIBDIR) $(INCDIR)
	$(CP) $(PWD)/common.h               $(INCDIR)/common.h
	$(CP) $(PWD)/a_star_api.h           $(INCDIR)/a_star_api.h
	$(CP) $(PWD)/a_star_impl.h          $(INCDIR)/a_star_impl.h
	$(CP) $(PWD)/$(LIBA)                $(LIBDIR)/$(LIBA)

uninstall:
	-rm $(INCDIR)/*_api.h $(INCDIR)/*_impl.h $(INCDIR)/common.h $(LIBDIR)/$(LIBA)
	-rmdir $(INCDIR)

install:
	make install_ CP="cp"

linstall:
	make install_ CP="ln -s"

clean:
	-rm $(LIBA) $(OBJS) tester tester.o

=== src_plugins/act_draw/Makefile ===
all:
	cd ../../src && $(MAKE) mod_act_draw
	

clean:
	rm *.o *.so 2>/dev/null ; true

=== debian/changelog ===
pcb-rnd (3.1.7b-2) unstable; urgency=medium

  * add -std=c17 and -Wno-error=implicit-function-declaration to innoculate 
    against gcc 15 changes and "the good old GNU flex bug", closes: #1097557

 -- Bdale Garbee <bdale@gag.com>  Sun, 07 Sep 2025 01:15:38 -0600

pcb-rnd (3.1.7b-1) unstable; urgency=medium

  * new upstream version, reverts poly lib default

 -- Bdale Garbee <bdale@gag.com>  Thu, 26 Jun 2025 16:01:29 -0600

pcb-rnd (3.1.7-1) unstable; urgency=medium

  * new upstream version
  * add Provides: pcb to the pcb-rnd binary package in preparation for 
    removal of the pcb package from Debian.

 -- Bdale Garbee <bdale@gag.com>  Wed, 21 May 2025 13:18:52 -0600

=== debian/control ===
--- 
+++ 
@@ -26,6 +26,7 @@
 	pcb-rnd-doc (= ${source:Version}),
 	pcb-rnd-import-net (= ${binary:Version})
 Suggests: camv-rnd, route-rnd, sch-rnd
+Provides: pcb
 Description: Standard installation of pcb-rnd
  pcb-rnd is a highly modular PCB (Printed Circuit Board) layout tool
  with a rich set of plugins for communicating with various external
@@ -56,6 +57,8 @@
      * dsn board
      * eagle xml board version 6, 7, 8
      * eagle binary board version 3, 4, 5
+     * EasyEDA std board
+     * EasyEDA pro board
      * hyperlynx board, version 2 and above
      * kicad board, version 3, 4 and 5 (s-expr)
      * lihata pcb-rnd board (any version)
@@ -76,12 +79,15 @@
      * eagle xml footprint lib .lbr (as board)
      * eagle xml footprint lib .lbr (as footprint)
      * eagle binary footprint lib (as board)
+     * EasyEDA std footprint
+     * EasyEDA pro footprint
+     * kicad footprint module (s-expr, version 3, 4 and 4)
      * lihata pcb-rnd footprint (any version)
      * Mentor Graphics cell footprints
      * gEDA/PCB .fp footprints
      * tEDAx footprint (any version)
    - export footprint:
-     * kicad module (s-expr, according to version 3)
+     * kicad footprint module (s-expr, according to version 3)
      * kicad pcbnew-module (legacy plain text format)
      * lihata pcb-rnd footprint (any version)
      * gEDA/PCB .fp footprints

=== debian/rules ===
--- 
+++ 
@@ -8,6 +8,9 @@
 # Workaround on exotic archs, probably any 32 bit arch with 64 bit kernel
 # see bug #1019729
 CFLAGS += -D_LARGE_FILE_SOURCE=1 -D_FILE_OFFSET_BITS=64
+
+# resolve FTBFS with gcc 15 until upstream comes up with a better solution
+CFLAGS += -std=c17 -Wno-error=implicit-function-declaration
 
 %:
 ifeq (mipsel,$(findstring mipsel,$(DEB_HOST_ARCH)))
@@ -59,6 +62,8 @@
 		--buildin-lib_formula \
 		--buildin-extedit \
 		--buildin-draw_pnp \
+		--plugin-rbs_routing \
+		--plugin-io_easyeda \
 		--plugin-export_excellon \
 		--plugin-export_fidocadj \
 		--plugin-export_lpr \
@@ -77,7 +82,6 @@
 		--plugin-polycombine \
 		--plugin-export_gcode \
 		--plugin-export_bom \
-		--plugin-ar_cpcb \
 		--plugin-lib_hid_pcbui \
 		--plugin-teardrops \
 		--plugin-shand_cmd \
